<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#" xmlns:pars="pars" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:MR="http://toldskat.dk/xml/schemas/metadatarepository/">
	<xsl:namespace-alias stylesheet-prefix="tsi" result-prefix="tsi"/>
	
	<xsl:output method="text" indent="yes" omit-xml-declaration="no" encoding="UTF-8" media-type="text"/>

	<xsl:template match="text()">
		<!-- <xsl:value-of select="."/>	 -->
	</xsl:template>
		
	<xsl:template match="/SAEncyclopedia/SAContent/SADefinition[./@SAObjMinorTypeName='Data Structure']"> 
		<!-- <xsl:copy-of select="."/> -->
		<xsl:apply-templates select=".//p-block">
			<xsl:with-param name="DSName" select="./@SAObjName"/>
			<xsl:with-param name="GUID" select="concat('sa:guid-',./SAProperty[./@SAPrpName='GUID']/@SAPrpValue)"/>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-block">
		<xsl:param name="DSName"/>
		<xsl:param name="GUID"/>
		<xsl:apply-templates>
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="string('/')"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-sequence[name(preceding-sibling::node()[2])='p-comment']">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:apply-templates select="*[local-name()!='p-comment']">
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="concat($CurrentPath,string(preceding-sibling::node()[2]/p-element/@name),'/')"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-choice[name(preceding-sibling::node()[2])='p-comment']">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:apply-templates select="*[local-name()!='p-comment']">
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="concat($CurrentPath,string(preceding-sibling::node()[2]/p-element/@name),'/')"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-optional[name(preceding-sibling::node()[2])='p-comment']">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:apply-templates select="*[local-name()!='p-comment']">
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="concat($CurrentPath,string(preceding-sibling::node()[2]/p-element/@name),'/')"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-sequence[name(preceding-sibling::node()[2])!='p-comment']">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:apply-templates>
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="$CurrentPath"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-choice[name(preceding-sibling::node()[2])!='p-comment']">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:apply-templates>
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="$CurrentPath"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-optional[name(preceding-sibling::node()[2])!='p-comment']">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:apply-templates>
			<xsl:with-param name="DSName"><xsl:value-of select="$DSName"/></xsl:with-param>
			<xsl:with-param name="GUID"><xsl:value-of select="$GUID"/></xsl:with-param>
			<xsl:with-param name="CurrentPath"><xsl:value-of select="$CurrentPath"/></xsl:with-param>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="p-element">
		<xsl:param name="DSName"/> 
		<xsl:param name="GUID"/>
		<xsl:param name="CurrentPath"/> 
		<xsl:value-of select="$GUID"/><xsl:text>,</xsl:text><xsl:value-of select="$DSName"/><xsl:text>,</xsl:text><xsl:value-of select="concat($CurrentPath,string(@name))"/><xsl:text>,,,
</xsl:text>
	</xsl:template>
	
</xsl:stylesheet>
