<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#" xmlns:daml="daml" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:MR="http://toldskat.dk/xml/schemas/metadatarepository/">
	<!-- BUGS TO FIX:

- Repetitioner af include skal fjernes
- Stereotype 'Service' skal danne rigtige WSDL-byggeblokke

-->
	<!-- <xsl:import href="reparse.xsl"/> -->
	<xsl:template match="text()"/>
	<!-- To get rid of unwanted newlines, spaces etc. -->
	<xsl:output method="xml" indent="yes" omit-xml-declaration="no" encoding="UTF-8" media-type="text"/>

	<xsl:param name="OutputTargetNamespace"/>
	<xsl:param name="nsPrefix"/>
	<xsl:param name="revision"/>

	<xsl:strip-space elements=" "/>
	<!--<xsl:preserve-space elements=" " />-->
	<xsl:variable name="Package">Begrebsmodel</xsl:variable>
	<xsl:variable name="OutputEncoding">UTF-8</xsl:variable>
	<!--<xsl:variable name="OutputTargetNamespace">http://toldskat.dk/xml/schemas/raplet/2005/01/01/</xsl:variable>-->
	<!--<xsl:variable name="nsPrefix">tsi:</xsl:variable>-->
	<xsl:variable name="MetadataNamespace">http://toldskat.dk/xml/schemas/metadatarepository/</xsl:variable>
	<!--<xsl:template match="/SAEncyclopedia">
	<xsl:apply-templates/>
</xsl:template> -->

	<xsl:template match="/SAEncyclopaedia">
		<xsl:message>
			<xsl:text>Namespace=</xsl:text><xsl:value-of select="$OutputTargetNamespace"/><xsl:text>
</xsl:text>
			<xsl:text> Prefix=</xsl:text><xsl:value-of select="$nsPrefix"/><xsl:text>
</xsl:text>
		</xsl:message>
	</xsl:template>
	<xsl:template match="/SAEncyclopedia/SAMetaData">
</xsl:template>
	<xsl:template match="/SAEncyclopedia/SADiagram">
</xsl:template>


<!-- Define simple data TYPES from the Data Domains -->
	<xsl:template match="/SAEncyclopedia/SAContent/SADefinition[@SAObjMinorTypeName='Data Domain']">
		<xsl:variable name="GUID">
			<xsl:value-of select="./SAProperty[@SAPrpName='GUID']/@SAPrpValue"/>
		</xsl:variable>
		<xsl:variable name="SAObjName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="ThisClassName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="ThisFileName">
			<xsl:value-of select="$ThisClassName"/><xsl:text>Type</xsl:text><xsl:text>.xsd</xsl:text>
		</xsl:variable>
		<xsl:message terminate="no">
			<xsl:text>
		Found Data Domain Definition: </xsl:text>
			<xsl:value-of select="@SAObjName"/>
		</xsl:message>

		<!-- Generate File Mapping -->
		<xsl:element name="mapping">
			<xsl:element name="theUri"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:element>
			<xsl:element name="theXpath"><xsl:text>types/</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:element>
		</xsl:element>
		<xsl:text> 

</xsl:text>

		<xsl:comment>
			<xsl:text>types/</xsl:text><xsl:value-of select="$ThisFileName"/>
		</xsl:comment>
		<xsl:text>
&lt;?xml version="1.0" encoding="</xsl:text>
		<xsl:value-of select="$OutputEncoding"/>
		<xsl:text>"?&gt;
</xsl:text>

		<!-- Generate RDF triplet -->
		<xsl:element name="rdf:Description">
			<xsl:attribute name="rdf:about"><xsl:text>sa:guid-</xsl:text><xsl:value-of select="$GUID"/></xsl:attribute>
			<xsl:attribute name="rdfs:label"><xsl:value-of select="$SAObjName"/></xsl:attribute>
			<xsl:element name="MR:generates">
				<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
			</xsl:element>
		</xsl:element>

		<!-- Generate RDF Description of node -->
		<xsl:element name="rdf:Description">
			<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
			<xsl:attribute name="rdfs:label"><xsl:value-of select="$SAObjName"/></xsl:attribute>
		</xsl:element>

		<xsl:element name="xs:schema" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/">
			<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
			<xsl:attribute name="elementFormDefault">qualified</xsl:attribute>
			<!-- <xsl:attribute name="attributeFormDefault">unqualified</xsl:attribute> -->
			<xsl:attribute name="version">1.0</xsl:attribute>
			<!-- <xsl:attribute name="xmlns:tsi"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> --> <!-- fixed in subsequent pass -->
			<xsl:attribute name="xmlns:xs">http://www.w3.org/2001/XMLSchema</xsl:attribute>
			<xsl:attribute name="xmlns:MR"><xsl:value-of select="$MetadataNamespace"/></xsl:attribute>
			<!--<xsl:attribute name="MR:GUID"><xsl:value-of select="$GUID"/></xsl:attribute> -->

			<xsl:if test="not(./SAProperty[@SAPrpName='Domain'])">
				<xsl:apply-templates select="." mode="simpletypedef">
					<xsl:with-param name="ThisClassName"><xsl:value-of select="$ThisClassName"/></xsl:with-param>
				</xsl:apply-templates>
			</xsl:if>
			<xsl:if test="./SAProperty[@SAPrpName='Domain']">
				<xsl:variable name="thisLink"><xsl:value-of select="./SAProperty[@SAPrpName='Domain']/SALink/@SALinkIdentity"/></xsl:variable>
				<xsl:apply-templates select="//SADefinition[translate($thisLink,' ','')=translate(translate(@SAObjId,'_',''),' ','')]" mode="simpletypedef">
					<xsl:with-param name="ThisClassName"><xsl:value-of select="$ThisClassName"/></xsl:with-param>
				</xsl:apply-templates>
			</xsl:if>
			<xsl:call-template name="simpletype-declaration">
				<xsl:with-param name="ThisClassName"><xsl:value-of select="@SAObjName"/></xsl:with-param>
			</xsl:call-template>
		</xsl:element>
	</xsl:template>

<!-- Define simple data TYPES from the Data Elements -->
	<xsl:template match="/SAEncyclopedia/SAContent/SADefinition[@SAObjMinorTypeName='Data Element']">
		<xsl:variable name="GUID">
			<xsl:value-of select="./SAProperty[@SAPrpName='GUID']/@SAPrpValue"/>
		</xsl:variable>
		<xsl:variable name="SAObjName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="ThisClassName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>

		<xsl:variable name="DataDomainLink"><xsl:value-of select="translate(./SAProperty[@SAPrpName='Domain']/SALink/@SALinkIdentity,' ','')"/></xsl:variable>
		
		<xsl:variable name="ThisTypeName"><xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Data Domain' and @SAObjId=concat('_',$DataDomainLink)]/@SAObjName"/><xsl:text>Type</xsl:text></xsl:variable>
		<xsl:variable name="ThisFileName"><xsl:value-of select="$ThisTypeName"/><xsl:text>.xsd</xsl:text></xsl:variable>




		<xsl:variable name="ThisUniqueClassID">
			<xsl:value-of select="@SAObjId"/>
		</xsl:variable>



		<xsl:message terminate="no">
			<xsl:text>
		Found Data Element Definition: </xsl:text>
			<xsl:value-of select="$ThisClassName"/>
		</xsl:message>

		<xsl:variable name="AttributeRefs"><xsl:value-of select="count(//SADefinition[@SAObjMinorTypeName='Class Attribute']/SAProperty[@SAPrpName='Class Name' and ../SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate(translate($ThisUniqueClassID,'_',''),' ','')]])"/></xsl:variable>

		<!-- Hvis dette Data Element genbruges i flere klasser, så erklæres også et selvstændigt ELEMENT -->
		<xsl:choose>
		
		
			<!-- <xsl:when test="1=1"> -->
			<xsl:when test="$AttributeRefs != 1">
				<!-- Der er flere klasser der kvalificerer dette Data Element. Måske skal der begrænses til stereotype for alm. UML klasse -->
				<!-- Definer et selvstændigt Data Element -->
				<xsl:message terminate="no">
					<xsl:text>
		Define XSD Element for: </xsl:text>
					<xsl:value-of select="$ThisClassName"/>
				</xsl:message>
				<xsl:text>
					<!-- Definer en file med en data type baseret på dette Data Element -->
				</xsl:text>
				
				<xsl:variable name="finalFileName">
					<xsl:choose>
					<xsl:when test="$AttributeRefs=0">
						<xsl:text>operational/</xsl:text><xsl:value-of select="$ThisClassName"/>
						<xsl:text>.xsd</xsl:text>
					</xsl:when>
					<xsl:when test="$AttributeRefs>1">
						<xsl:text>types/</xsl:text><xsl:value-of select="$ThisClassName"/>
						<xsl:text>.xsd</xsl:text>
					</xsl:when>
					</xsl:choose>
				</xsl:variable>

				<!-- Generate File Mapping -->
				<xsl:element name="mapping">
					<xsl:element name="theUri"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.xsd</xsl:text></xsl:element>
					<xsl:element name="theXpath"><xsl:value-of select="$finalFileName"/></xsl:element>
				</xsl:element>
						<xsl:text> 

</xsl:text>

				<xsl:comment>
					<xsl:value-of select="$finalFileName"/>
				</xsl:comment>

				<xsl:text>
&lt;?xml version="1.0" encoding="</xsl:text>
				<xsl:value-of select="$OutputEncoding"/>
				<xsl:text>"?&gt;
</xsl:text>

				<!-- Generate RDF triplet -->
				<xsl:element name="rdf:Description">
					<xsl:attribute name="rdf:about"><xsl:text>sa:guid-</xsl:text><xsl:value-of select="./SAProperty[@SAPrpName='GUID']/@SAPrpValue"/></xsl:attribute>
					<xsl:element name="MR:generates">
						<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.xsd</xsl:text></xsl:attribute>
					</xsl:element>
				</xsl:element>

				<xsl:element name="xs:schema" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/">
					<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
					<xsl:attribute name="elementFormDefault">qualified</xsl:attribute>
					<!-- <xsl:attribute name="attributeFormDefault">unqualified</xsl:attribute> -->
					<xsl:attribute name="version">1.0</xsl:attribute>
					<!--<xsl:attribute name="xmlns:tsi"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> --> <!-- fixed in subsequent pass -->
					<xsl:attribute name="xmlns:xs">http://www.w3.org/2001/XMLSchema</xsl:attribute>
					<xsl:attribute name="xmlns:MR"><xsl:value-of select="$MetadataNamespace"/></xsl:attribute>


					<xsl:element name="xs:include">
						<xsl:attribute name="schemaLocation"><xsl:text>../types/</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
					</xsl:element>

					<!-- Generate RDF triplet -->
					<xsl:element name="rdf:Description">
						<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/>
					<xsl:text>.xsd</xsl:text></xsl:attribute>
						<xsl:element name="MR:includes">
							<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
						</xsl:element>
					</xsl:element>
					
					<xsl:element name="xs:element">
						<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/></xsl:attribute>
						<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisTypeName"/></xsl:attribute>
						<xsl:if test="string-length(./SAProperty[@SAPrpName='Description']/@SAPrpValue)>0 or string-length(./SAProperty[@SAPrpName='Beskrivelse']/@SAPrpValue)>0">
							<xsl:element name="xs:annotation">
								<xsl:element name="xs:documentation">
									<!-- <xsl:text>Template match Data Element</xsl:text> -->
									<xsl:choose>
									<xsl:when test="string-length(./SAProperty[@SAPrpName='Beskrivelse']/@SAPrpValue)>0">
									    <xsl:value-of select="./SAProperty[@SAPrpName='Beskrivelse']/@SAPrpValue"/>
									</xsl:when>
									<xsl:otherwise>
									  <xsl:value-of select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/>
									</xsl:otherwise>
									</xsl:choose>
								</xsl:element>
							</xsl:element>
						</xsl:if>
					</xsl:element>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	

	<xsl:template match="SADefinition[@SAObjMinorTypeName='Data Element']" mode="simpletypedef">
		<xsl:param name="ThisClassName"/>
		<!-- <xsl:call-template name="simpletype-declaration"><xsl:with-param name="ThisClassName"><xsl:value-of select="$ThisClassName"/></xsl:with-param></xsl:call-template> -->
	</xsl:template>

	<xsl:template match="SADefinition[@SAObjMinorTypeName='Data Domain']" mode="simpletypedef">
		<xsl:param name="ThisClassName"/>
		<!-- <xsl:call-template name="simpletype-declaration"><xsl:with-param name="ThisClassName"><xsl:value-of select="$ThisClassName"/></xsl:with-param></xsl:call-template> -->
	</xsl:template>
	
	<xsl:template name="simpletype-declaration">
		<xsl:param name="ThisClassName"/>
		<xsl:variable name="SADataType">
			<xsl:value-of select="./SAProperty[@SAPrpName='SQL Data Type']/@SAPrpValue"/>
		</xsl:variable>

		<xsl:variable name="XSDDataType">
			<xsl:choose> <!-- Conversion of SA data types (SQL '92) to XSD data types -->
				<xsl:when test="$SADataType='anyXML'"><xsl:text>anyXML</xsl:text></xsl:when>
				<xsl:when test="$SADataType='anyURI'"><xsl:text>anyURI</xsl:text></xsl:when>
				<xsl:when test="$SADataType='binary'"><xsl:text>base64Binary</xsl:text></xsl:when>
				<xsl:when test="$SADataType='bit'"><xsl:text>boolean</xsl:text></xsl:when>
				<xsl:when test="$SADataType='character'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='character varying'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='date'"><xsl:text>date</xsl:text></xsl:when>
				<xsl:when test="$SADataType='datetime'"><xsl:text>dateTime</xsl:text></xsl:when>
				<xsl:when test="$SADataType='decimal'"><xsl:text>decimal</xsl:text></xsl:when>
				<xsl:when test="$SADataType='double precision'"><xsl:text>double</xsl:text></xsl:when>
				<xsl:when test="$SADataType='float'"><xsl:text>float</xsl:text></xsl:when>
				<xsl:when test="$SADataType='graphic'"><xsl:text>base64Binary</xsl:text></xsl:when>
				<xsl:when test="$SADataType='image'"><xsl:text>base64Binary</xsl:text></xsl:when>
				<xsl:when test="$SADataType='integer'"><xsl:text>integer</xsl:text></xsl:when>
				<xsl:when test="$SADataType='long binary'"><xsl:text>hexBinary</xsl:text></xsl:when>
				<xsl:when test="$SADataType='long character'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='long text'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='long var character'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='money'"><xsl:text>decimal</xsl:text></xsl:when>
				<xsl:when test="$SADataType='national character'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='national var character'"><xsl:text>string</xsl:text></xsl:when>
				<xsl:when test="$SADataType='number'"><xsl:text>integer</xsl:text></xsl:when>
				<xsl:when test="$SADataType='QName'"><xsl:text>QName</xsl:text></xsl:when>
				<xsl:when test="$SADataType='real'"><xsl:text>float</xsl:text></xsl:when>
				<xsl:when test="$SADataType='small integer'"><xsl:text>int</xsl:text></xsl:when>
				<xsl:when test="$SADataType='time'"><xsl:text>time</xsl:text></xsl:when>
				<xsl:when test="$SADataType='timestamp'"><xsl:text>dateTime</xsl:text></xsl:when>
				<xsl:when test="$SADataType='tiny integer'"><xsl:text>short</xsl:text></xsl:when>
			</xsl:choose>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="$XSDDataType='anyXML'"> <!-- 'any' construct requires a complexType -->
				<xsl:element name="xs:complexType">
					<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>Type</xsl:text></xsl:attribute>
					<xsl:element name="xs:sequence">
						<xsl:element name="xs:any">
							<xsl:attribute name="namespace"><xsl:text>##any</xsl:text></xsl:attribute>
							<xsl:attribute name="processContents"><xsl:text>skip</xsl:text></xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise> <!-- otherwise we define types as restrictions on simple types -->
				<xsl:element name="xs:simpleType">
					<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>Type</xsl:text></xsl:attribute>
					<!-- Conversion from System Architect data types to XSD data types -->
					<xsl:if test="string-length(./SAProperty[@SAPrpName='Description']/@SAPrpValue)>0">
						<xsl:element name="xs:annotation">
							<xsl:element name="xs:documentation">
								<!-- <xsl:text>Template match simpletype-declaration</xsl:text> -->
								<xsl:value-of select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/>
							</xsl:element>
						</xsl:element>
					</xsl:if>
					<xsl:element name="xs:restriction">
						<xsl:attribute name="base"><xsl:text>xs:</xsl:text><xsl:value-of select="$XSDDataType"/></xsl:attribute>
	
					
						<!--  Valid facets for the different XSD data types
	
string 					length, 	minLength, 	maxLength, 	pattern, 	enumeration, 	whiteSpace 
boolean 																			pattern, 							whiteSpace 
float 																				pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
double 																			pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
decimal 																			pattern,	enumeration,	whiteSpace,	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive,	 totalDigits, 	fractionDigits 
integer 																			pattern,	enumeration,	whiteSpace,	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive,	 totalDigits, 	fractionDigits 
int		 																			pattern,	enumeration,	whiteSpace,	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive,	 totalDigits, 	fractionDigits 
short	 																			pattern,	enumeration,	whiteSpace,	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive,	 totalDigits, 	fractionDigits 
duration 																			pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
dateTime 																		pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
time 																				pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
date 																				pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
gYearMonth 																	pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
gYear 																				pattern,  	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
gMonthDay 																		pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
gDay 																				pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
gMonth 																			pattern, 	enumeration, 	whiteSpace, 	maxInclusive, 	maxExclusive, 	minInclusive, 	minExclusive 
hexBinary 			length, 	minLength, 	maxLength, 	pattern, 	enumeration, 	whiteSpace 
base64Binary 	length, 	minLength, 	maxLength, 	pattern, 	enumeration, 	whiteSpace 
anyURI 				length, 	minLength, 	maxLength, 	pattern, 	enumeration, 	whiteSpace 
QName 				length, 	minLength, 	maxLength, 	pattern, 	enumeration, 	whiteSpace 
NOTATION 			length, 	minLength, 	maxLength, 	pattern, 	enumeration, 	whiteSpace 
any

					-->
		
							<xsl:if test="(./SAProperty[@SAPrpName='XSD Facet Length']) and ($XSDDataType='string' or $XSDDataType='hexBinary' or $XSDDataType='base64Binary' or $XSDDataType='anyURI' or $XSDDataType='QName' or $XSDDataType='NOTATION')">
								<xsl:if test="./SAProperty[@SAPrpName='XSD Facet Length']">
									<xsl:element name="xs:length">
										<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet Length']/@SAPrpValue"/></xsl:attribute>
									</xsl:element>
								</xsl:if>
							</xsl:if>
								
							<xsl:if test="./SAProperty[@SAPrpName='XSD Facet minLength'] and ($XSDDataType='string' or $XSDDataType='hexBinary' or $XSDDataType='base64Binary' or $XSDDataType='anyURI' or $XSDDataType='QName' or $XSDDataType='NOTATION')">
								<xsl:element name="xs:minLength">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet minLength']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
		
							<xsl:if test="./SAProperty[@SAPrpName='SQL Type Qualifiers' or @SAPrpName='XSD Facet maxLength'] and ($XSDDataType='string' or $XSDDataType='hexBinary' or $XSDDataType='base64Binary' or $XSDDataType='anyURI' or $XSDDataType='QName' or $XSDDataType='NOTATION')">
								<xsl:element name="xs:maxLength">
									<xsl:choose>
										<xsl:when test="./SAProperty[@SAPrpName='XSD Facet maxLength']">
											<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet maxLength']/@SAPrpValue"/></xsl:attribute>
										</xsl:when>
										<xsl:otherwise>
											<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='SQL Type Qualifiers']/@SAPrpValue"/></xsl:attribute>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:element>
							</xsl:if>
		
							<xsl:if test="(./SAProperty/@SAPrpName='XSD Facet pattern') and ($XSDDataType='string' or $XSDDataType='boolean' or $XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='hexBinary' or $XSDDataType='base64Binary' or $XSDDataType='anyURI' or $XSDDataType='QName' or $XSDDataType='NOTATION' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:pattern">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet pattern']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
		
							<xsl:if test="(./SAProperty/@SAPrpName='XSD Facet enumeration') and ($XSDDataType='string' or $XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='hexBinary' or $XSDDataType='base64Binary' or $XSDDataType='anyURI' or $XSDDataType='QName' or $XSDDataType='NOTATION' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:for-each select="./SAProperty[@SAPrpName='XSD Facet enumeration']/p-enumeration">
									<xsl:element name="xs:enumeration">
										<xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
									</xsl:element>
								</xsl:for-each>
							</xsl:if>
								
							<xsl:if test="(./SAProperty/@SAPrpName='XSD Facet whitespace') and ($XSDDataType='string' or $XSDDataType='boolean' or $XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='hexBinary' or $XSDDataType='base64Binary' or $XSDDataType='anyURI' or $XSDDataType='QName' or $XSDDataType='NOTATION' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:whiteSpace">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet whitespace']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
								
							<xsl:if test="(./SAProperty[@SAPrpName='XSD Facet maxInclusive']) and ($XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:maxInclusive">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet maxInclusive']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
								
							<xsl:if test="(./SAProperty[@SAPrpName='XSD Facet minInclusive']) and ($XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:minInclusive">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet minInclusive']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
								
							<xsl:if test="(./SAProperty[@SAPrpName='XSD Facet maxExclusive']) and ($XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:maxExclusive">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet maxExclusive']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
								
							<xsl:if test="(./SAProperty[@SAPrpName='XSD Facet minExclusive']) and ($XSDDataType='float' or $XSDDataType='double' or $XSDDataType='decimal' or $XSDDataType='fractionDigits' or $XSDDataType='duration' or $XSDDataType='dateTime' or $XSDDataType='time' or $XSDDataType='date' or $XSDDataType='gYearMonth' or $XSDDataType='gYear' or $XSDDataType='gMonthDay' or $XSDDataType='gMonth' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:minExclusive">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet minExclusive']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
								
							<xsl:if test="(./SAProperty[@SAPrpName='SQL Type Qualifiers' or @SAPrpName='XSD Facet totalDigits']) and ($XSDDataType='decimal' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:totalDigits">
									<xsl:choose>
										<xsl:when test="./SAProperty[@SAPrpName='XSD Facet totalDigits']">
											<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet totalDigits']/@SAPrpValue"/></xsl:attribute>
										</xsl:when>
										<xsl:otherwise>
											<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='SQL Type Qualifiers']/@SAPrpValue"/></xsl:attribute>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:element>
							</xsl:if>
		
							<xsl:if test="(./SAProperty[@SAPrpName='XSD Facet fractionDigits']) and ($XSDDataType='decimal' or $XSDDataType='integer' or $XSDDataType='int' or $XSDDataType='short')">
								<xsl:element name="xs:fractionDigits">
									<xsl:attribute name="value"><xsl:value-of select="./SAProperty[@SAPrpName='XSD Facet fractionDigits']/@SAPrpValue"/></xsl:attribute>
								</xsl:element>
							</xsl:if>
		
						<!-- Test the different attribute types for restrictions that may be converted to schema data type restrictions -->
					</xsl:element>
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


<!-- Define the basic collection of elements corresponding to the UML CLASS -->
<!-- (classes with stereotype different from "Services")... and get rid of programming language classes -->

	<xsl:template match="SADefinition[@SAObjMinorTypeName='Class' and (not(SAProperty/@SAPrpName='Stereotype') or string-length(SAProperty[@SAPrpName='Stereotype']/@SAPrpValue)=0) and SAProperty[@SAPrpName='Package' and translate(@SAPrpValue,'&quot;','')!='C++ Types' and translate(@SAPrpValue,'&quot;','')!='Java Types' and translate(@SAPrpValue,'&quot;','')!='VB Types' and translate(@SAPrpValue,'&quot;','')!='CORBA IDL']]">
		<!-- Her kan der filtreres på stereotype!='Service' -->
		<xsl:if test=" not(SAProperty[@SAPrpName='Stereotype' and @SAPrpValue='Services'])">
		<xsl:variable name="GUID">
			<xsl:text>sa:guid-</xsl:text><xsl:value-of select="./SAProperty[@SAPrpName='GUID']/@SAPrpValue"/>
		</xsl:variable>
		<xsl:variable name="ThisClassName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="SAObjName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="ThisFileName">
			<xsl:value-of select="$ThisClassName"/><xsl:text>.xsd</xsl:text>
		</xsl:variable>
		<xsl:variable name="ThisUniqueClassID">
			<xsl:value-of select="@SAObjId"/>
		</xsl:variable>
		<xsl:message terminate="no">
			<xsl:text>
		Found Class Definition: </xsl:text>
			<xsl:value-of select="$ThisClassName"/>
		</xsl:message>
		<xsl:text>

</xsl:text>

		<!-- Generate File Mapping -->
		<xsl:element name="mapping">
			<xsl:element name="theUri"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:element>
			<xsl:element name="theXpath"><xsl:text>class/</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:element>
		</xsl:element>
		<xsl:text> 

</xsl:text>

		<xsl:comment>
			<xsl:text>class/</xsl:text><xsl:value-of select="$ThisFileName"/>
		</xsl:comment>
		<xsl:text>
&lt;?xml version="1.0" encoding="</xsl:text>
		<xsl:value-of select="$OutputEncoding"/>
		<xsl:text>"?&gt;
</xsl:text>
		<xsl:element name="xs:schema" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/">
			<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
			<xsl:attribute name="elementFormDefault">qualified</xsl:attribute>
			<xsl:attribute name="attributeFormDefault">unqualified</xsl:attribute>
			<xsl:attribute name="version">1.0</xsl:attribute>
			<!--<xsl:attribute name="xmlns:tsi"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> --> <!-- fixed in subsequent pass -->
			<xsl:attribute name="xmlns:MR"><xsl:value-of select="$MetadataNamespace"/></xsl:attribute>
			<xsl:attribute name="xmlns:xs">http://www.w3.org/2001/XMLSchema</xsl:attribute>
			<!--<xsl:attribute name="MR:GUID"><xsl:value-of select="$GUID"/></xsl:attribute>-->
			<!--	The collection of elements defined by the UML Classes -->


			<xsl:element name="rdf:Description">
				<xsl:attribute name="rdf:about"><xsl:value-of select="$GUID"/></xsl:attribute>
				<xsl:attribute name="rdfs:label"><xsl:value-of select="$SAObjName"/></xsl:attribute>
				<xsl:element name="MR:generates">
					<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
				</xsl:element>
			</xsl:element>

			<xsl:if test="string-length(./SAProperty[@SAPrpName='Description']/@SAPrpValue)>0">
				<xsl:element name="xs:annotation">
					<xsl:element name="xs:documentation">
						<!-- <xsl:text>Template match Class</xsl:text> -->
						<xsl:value-of select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/>
					</xsl:element>
				</xsl:element>
			</xsl:if>

			<xsl:apply-templates select="./SAProperty[@SAPrpName='Attributes']/SALink" mode="class-import-declaration">
				<xsl:with-param name="ThisFileName"><xsl:value-of select="$ThisFileName"/></xsl:with-param>
			</xsl:apply-templates>
			<xsl:apply-templates select="./SAProperty[@SAPrpName='Attributes']/SALink" mode="class-import-definition"/>
		</xsl:element>
		</xsl:if>
	</xsl:template>
	
<!-- Define interfaces and wsdl files from classes of stereotype 'Service' -->
<!-- We only generate for those definitions that have property  Servicekategori="Forretning" -->
<!-- og doesn't have the property at all (equal to "Forretning") -->

	<xsl:template match="SADefinition[@SAObjMinorTypeName='Class' and SAProperty[@SAPrpName='Stereotype' and @SAPrpValue='Services'] and not(SAProperty[@SAPrpName='Servicekategori' and @SAPrpValue!='Forretning']) and SAProperty[@SAPrpName='Package' and translate(@SAPrpValue,'&quot;','')!='C++ Types' and translate(@SAPrpValue,'&quot;','')!='Java Types' and translate(@SAPrpValue,'&quot;','')!='VB Types' and translate(@SAPrpValue,'&quot;','')!='CORBA IDL']]">
		<xsl:variable name="GUID">
			<xsl:text>sa:guid-</xsl:text><xsl:value-of select="./SAProperty[@SAPrpName='GUID']/@SAPrpValue"/>
		</xsl:variable>
		<xsl:variable name="ThisClassName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="SAObjName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="ThisUniqueClassID">
			<xsl:value-of select="@SAObjId"/>
		</xsl:variable>
		
		
		<xsl:message terminate="no">
			<xsl:text>
		Found Service Definition: </xsl:text>
			<xsl:value-of select="$ThisClassName"/><xsl:text>Service</xsl:text>
		</xsl:message>
		<xsl:text>

</xsl:text>


		<!-- Generate INTERFACE schema -->


		<!-- Generate File Mapping -->
		<xsl:element name="mapping">
			<xsl:element name="theUri"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:element>
			<xsl:element name="theXpath"><xsl:text>service/</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:element>
		</xsl:element>
		<xsl:text> 

</xsl:text>

		<xsl:comment>
			<xsl:text>service/</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text>
		</xsl:comment>
		<xsl:text>
&lt;?xml version="1.0" encoding="</xsl:text>
		<xsl:value-of select="$OutputEncoding"/>
		<xsl:text>"?&gt;
</xsl:text>
		<xsl:element name="xs:schema" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/">
			<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
			<xsl:attribute name="elementFormDefault">qualified</xsl:attribute>
			<xsl:attribute name="attributeFormDefault">unqualified</xsl:attribute>
			<xsl:attribute name="version">1.0</xsl:attribute>
			<!--<xsl:attribute name="xmlns:tsi"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> --> <!-- fixed in subsequent pass -->
			<xsl:attribute name="xmlns:MR"><xsl:value-of select="$MetadataNamespace"/></xsl:attribute>
			<xsl:attribute name="xmlns:xs">http://www.w3.org/2001/XMLSchema</xsl:attribute>
			<!--<xsl:attribute name="MR:GUID"><xsl:value-of select="$GUID"/></xsl:attribute>-->
			<!--	The collection of elements defined by the UML Classes -->

			<xsl:if test="string-length(./SAProperty[@SAPrpName='Description' or @SAPrpName='Formål']/@SAPrpValue)>00">
				<xsl:element name="xs:annotation">
					<xsl:element name="xs:documentation">

						<xsl:value-of select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/>
						<xsl:value-of select="./SAProperty[@SAPrpName='Formål']/@SAPrpValue"/>
					</xsl:element>
				</xsl:element>
			</xsl:if>


			<xsl:element name="rdf:Description">
				<xsl:attribute name="rdf:about"><xsl:value-of select="$GUID"/></xsl:attribute>
				<xsl:attribute name="rdfs:label"><xsl:value-of select="$SAObjName"/></xsl:attribute>
				<xsl:element name="MR:generates">
					<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:element>

		
			<xsl:for-each select="./SAProperty[@SAPrpName='Attributes']/SALink/@SALinkIdentity">
				<xsl:variable name="hubba"><xsl:value-of select="."/></xsl:variable>
				<xsl:element name="xs:include">
					<xsl:attribute name="schemaLocation"><xsl:text>../view/</xsl:text><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/><xsl:text>Type.xsd</xsl:text></xsl:attribute>
				</xsl:element>	
				
				<!-- Generate RDF triplet -->
				<xsl:element name="rdf:Description">
					<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:attribute>
					<xsl:element name="MR:includes">
						<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/><xsl:text>Type.xsd</xsl:text></xsl:attribute>
					</xsl:element>
				</xsl:element>

			</xsl:for-each>
	
			<!--			-->

			<xsl:element name="xs:include">
				<xsl:attribute name="schemaLocation"><xsl:text>../context/</xsl:text><xsl:text>KompenserTransType.xsd</xsl:text></xsl:attribute>
			</xsl:element>	
						
			<!-- Generate RDF triplet -->

			<xsl:element name="rdf:Description">
				<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:attribute>
				<xsl:element name="MR:includes">
					<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransType.xsd</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:element>

			<!--			-->

			<xsl:element name="xs:include">
				<xsl:attribute name="schemaLocation"><xsl:text>../context/</xsl:text><xsl:text>KompenserTransSvarType.xsd</xsl:text></xsl:attribute>
			</xsl:element>	
			
			<!-- Generate RDF triplet -->

			<xsl:element name="rdf:Description">
				<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:attribute>
				<xsl:element name="MR:includes">
					<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransSvarType.xsd</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:element>

			<xsl:element name="xs:element">
				<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>Interface</xsl:text></xsl:attribute>
				<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>InterfaceType</xsl:text></xsl:attribute>
			</xsl:element>
			<xsl:element name="xs:complexType">
				<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>InterfaceType</xsl:text></xsl:attribute>
				<xsl:element name="xs:choice">

					<xsl:for-each select="./SAProperty[@SAPrpName='Attributes']/SALink/@SALinkIdentity">
						<xsl:variable name="hubba"><xsl:value-of select="."/></xsl:variable>
						<xsl:element name="xs:element">
							<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/></xsl:attribute>
						</xsl:element>	
					</xsl:for-each>

					<!-- Skal vi eller skal vi ikke have Kompensering synlig på forretningsbussen??? -->
					<!--					-->

					<xsl:element name="xs:element">
						<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTrans</xsl:text></xsl:attribute>
					</xsl:element>	
					<xsl:element name="xs:element">
						<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransSvar</xsl:text></xsl:attribute>
					</xsl:element>	

				</xsl:element>
			</xsl:element>
		</xsl:element>


		<!-- Generate WSDL file -->

		<xsl:text>
		
		</xsl:text>

		<!-- Generate File Mapping -->
		<xsl:element name="mapping">
			<xsl:element name="theUri"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.wsdl</xsl:text></xsl:element>
			<xsl:element name="theXpath"><xsl:text>wsdl/</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.wsdl</xsl:text></xsl:element>
		</xsl:element>
		<xsl:text> 

</xsl:text>

		<xsl:comment>
			<xsl:text>wsdl/</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.wsdl</xsl:text>
		</xsl:comment>
		

			<xsl:element name="rdf:Description">
				<xsl:attribute name="rdf:about"><xsl:value-of select="$GUID"/></xsl:attribute>
				<xsl:attribute name="rdfs:label"><xsl:value-of select="$SAObjName"/></xsl:attribute>
				<xsl:element name="MR:generates">
					<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.wsdl</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:element>
			
		<xsl:text>
&lt;?xml version="1.0" encoding="</xsl:text>
		<xsl:value-of select="$OutputEncoding"/>
		<xsl:text>"?&gt;
</xsl:text>
		<xsl:element name="definitions" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/">
			<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
			<xsl:attribute name="xmlns"><xsl:text>http://schemas.xmlsoap.org/wsdl/</xsl:text></xsl:attribute>
			<xsl:attribute name="xmlns:soap"><xsl:text>http://schemas.xmlsoap.org/wsdl/soap/</xsl:text></xsl:attribute>
			<!--<xsl:attribute name="elementFormDefault">qualified</xsl:attribute>
			<xsl:attribute name="attributeFormDefault">unqualified</xsl:attribute>
			<xsl:attribute name="version">1.0</xsl:attribute> --><!-- fixed in subsequent pass -->
			<!--<xsl:attribute name="xmlns:tsi"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> --> <!-- fixed in subsequent pass -->
			<xsl:attribute name="xmlns:MR"><xsl:value-of select="$MetadataNamespace"/></xsl:attribute>
			<xsl:attribute name="xmlns:xsd"><xsl:text>http://www.w3.org/2001/XMLSchema</xsl:text></xsl:attribute>
			<!--<xsl:attribute name="MR:GUID"><xsl:value-of select="$GUID"/></xsl:attribute>-->
			<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>Service</xsl:text></xsl:attribute>
			<!--	The collection of elements defined by the UML Classes -->


			<xsl:if test="string-length(./SAProperty[@SAPrpName='Description' or @SAPrpName='Formål']/@SAPrpValue)>00">
				<xsl:element name="xs:annotation">
					<xsl:element name="xs:documentation">

						<xsl:value-of select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/>
						<xsl:value-of select="./SAProperty[@SAPrpName='Formål']/@SAPrpValue"/>
					</xsl:element>
				</xsl:element>
			</xsl:if>
			
			<xsl:element name="types">
				<xsl:element name="xsd:schema" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
					<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
					<xsl:attribute name="xmlns:xsd"><xsl:text>http://www.w3.org/2001/XMLSchema</xsl:text></xsl:attribute>
					<xsl:element name="xsd:include">
						<!--<xsl:attribute name="namespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> -->
						<xsl:attribute name="schemaLocation"><xsl:text>../service/</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:attribute>
					</xsl:element>	

					<!-- Generate RDF triplet -->
					<xsl:element name="rdf:Description">
						<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>.wsdl</xsl:text></xsl:attribute>
						<xsl:element name="MR:includes">
							<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>Interface.xsd</xsl:text></xsl:attribute>
						</xsl:element>
					</xsl:element>

					<!--					-->

					<!-- <xsl:element name="xsd:element">
						<xsl:attribute name="name"><xsl:text>KompenserTrans</xsl:text></xsl:attribute>
						<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransType</xsl:text></xsl:attribute>
					</xsl:element>	
					<xsl:element name="xsd:element">
						<xsl:attribute name="name"><xsl:text>KompenserTransSvar</xsl:text></xsl:attribute>
						<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransSvarType</xsl:text></xsl:attribute>
					</xsl:element>	-->
					
<!-- Det her er vist ikke nødvendigt når man genererer en Interfacefil. Hvis man går over til at inkludere de separate datastrukturer kan man bruge dette.

					<xsl:for-each select="./SAProperty[@SAPrpName='Attributes']/SALink/@SALinkIdentity">
						<xsl:variable name="hubba"><xsl:value-of select="."/></xsl:variable>
						<xsl:element name="xsd:element">
							<xsl:attribute name="name"><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/></xsl:attribute>
							<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/><xsl:text>Type</xsl:text></xsl:attribute>
						</xsl:element>	
						
					</xsl:for-each>
-->
				</xsl:element>
			</xsl:element>

			<xsl:for-each select="./SAProperty[@SAPrpName='Attributes']/SALink/@SALinkIdentity">
				<xsl:variable name="hubba"><xsl:value-of select="."/></xsl:variable>
				<xsl:variable name="IO"><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/SAProperty[@SAPrpName='InOutParam']/@SAPrpValue"/></xsl:variable>

					<xsl:choose>
						<xsl:when test="$IO='I'">
							<xsl:element name="message">
							<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>ServiceRequest</xsl:text></xsl:attribute>
							<xsl:element name="part">
								<xsl:attribute name="name"><xsl:text>Request</xsl:text></xsl:attribute>
								<xsl:attribute name="element"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/></xsl:attribute>
							</xsl:element>
							</xsl:element>	
						</xsl:when>
						<xsl:when test="$IO='O'">
							<xsl:element name="message">
							<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>ServiceResponse</xsl:text></xsl:attribute>
							<xsl:element name="part">
								<xsl:attribute name="name"><xsl:text>Response</xsl:text></xsl:attribute>
								<xsl:attribute name="element"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[translate(@SAObjId,' ','')=translate(concat('_',$hubba),' ','')]/@SAObjName"/></xsl:attribute>
							</xsl:element>
							</xsl:element>	
						</xsl:when>
					</xsl:choose>

						
			</xsl:for-each>


			<!--			-->

			<xsl:element name="message">
				<xsl:attribute name="name"><xsl:text>KompenserTransRequest</xsl:text></xsl:attribute>
				<xsl:element name="part">
					<xsl:attribute name="name"><xsl:text>Request</xsl:text></xsl:attribute>
					<xsl:attribute name="element"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTrans</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:element>	

			<xsl:element name="message">
				<xsl:attribute name="name"><xsl:text>KompenserTransResponse</xsl:text></xsl:attribute>
				<xsl:element name="part">
					<xsl:attribute name="name"><xsl:text>Response</xsl:text></xsl:attribute>
					<xsl:attribute name="element"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransSvar</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:element>	

			<xsl:element name="portType">
				<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>ServicePortType</xsl:text></xsl:attribute>
				<xsl:element name="operation">
					<xsl:attribute name="name"><xsl:text>get</xsl:text><xsl:value-of select="$ThisClassName"/></xsl:attribute>
					<xsl:element name="input">
						<xsl:attribute name="message"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>ServiceRequest</xsl:text></xsl:attribute>
					</xsl:element>
					<xsl:element name="output">
						<xsl:attribute name="message"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>ServiceResponse</xsl:text></xsl:attribute>
					</xsl:element>
				</xsl:element>

				<!--				-->

				<xsl:element name="operation">
					<xsl:attribute name="name"><xsl:text>get</xsl:text><xsl:text>KompenserTrans</xsl:text></xsl:attribute>
					<xsl:element name="input">
						<xsl:attribute name="message"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransRequest</xsl:text></xsl:attribute>
					</xsl:element>
					<xsl:element name="output">
						<xsl:attribute name="message"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KompenserTransResponse</xsl:text></xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:element>

			<xsl:comment>
				<xsl:element name="binding">
					<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>ServiceBinding</xsl:text></xsl:attribute>
					<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisClassName"/><xsl:text>ServicePortType</xsl:text></xsl:attribute>
				</xsl:element>


				<xsl:element name="service">
					<xsl:attribute name="name"><xsl:value-of select="$ThisClassName"/><xsl:text>Service</xsl:text></xsl:attribute>
				</xsl:element>
			</xsl:comment>
		
		</xsl:element>
	</xsl:template>


<!-- Støttefunktion til Class definition der inkluderer de datatype XSDer der er defineret for de enkelte attributter -->
	<xsl:template match="SALink" mode="class-import-declaration">
		<xsl:param name="ThisFileName"/>
		<xsl:variable name="LinkId"><xsl:value-of select="translate(@SALinkIdentity,' ','')"/></xsl:variable>
		<xsl:variable name="DataElementLink"><xsl:value-of select="translate(//SADefinition[@SAObjMinorTypeName='Class Attribute' and @SAObjId=concat('_',$LinkId)]/SAProperty[@SAPrpName='Source Data']/SALink/@SALinkIdentity,' ','')"/></xsl:variable>
		<xsl:variable name="DataDomainLink"><xsl:value-of select="translate(//SADefinition[@SAObjMinorTypeName='Data Element' and @SAObjId=concat('_',$DataElementLink)]/SAProperty[@SAPrpName='Domain']/SALink/@SALinkIdentity,' ','')"/></xsl:variable>
		
		<xsl:variable name="fileName"><xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Data Domain' and @SAObjId=concat('_',$DataDomainLink)]/@SAObjName"/><xsl:text>Type</xsl:text><xsl:text>.xsd</xsl:text></xsl:variable>

		
		<xsl:element name="xs:include">
			<xsl:attribute name="schemaLocation"><xsl:text>../types/</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
		</xsl:element>
					
					<!-- Generate RDF triplet -->
				<xsl:text>
				</xsl:text><xsl:comment>&lt;rdf:Description i SALink mode class-import-declaration&gt;</xsl:comment>
				<xsl:element name="rdf:Description">
					<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
					<xsl:element name="MR:includes">
						<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
					</xsl:element>
				</xsl:element>
					
	</xsl:template>
	


<!-- Støttefunktion til Class definition der definerer de elementer der svarer til de enkelte attributter ved brug af deres type-->
	<xsl:template match="SALink" mode="class-import-definition">
		<xsl:variable name="LinkId"><xsl:value-of select="translate(@SALinkIdentity,' ','')"/></xsl:variable> <!-- Link til Class Attribute -->
		<!--<xsl:message terminate="no"><xsl:text>LinkId='</xsl:text><xsl:value-of select="$LinkId"/><xsl:text>'</xsl:text></xsl:message>		-->

		<xsl:variable name="DELinkId"><xsl:value-of select="translate(//SADefinition[@SAObjMinorTypeName='Class Attribute' and translate(@SAObjId,' ','')=translate(concat('_',$LinkId),' ','')]/SAProperty[@SAPrpName='Source Data']/SALink/@SALinkIdentity,' ','')"/></xsl:variable> <!-- Link til Data Element -->

		<!--<xsl:message terminate="no"><xsl:text>DELinkId='</xsl:text><xsl:value-of select="$DELinkId"/><xsl:text>'</xsl:text></xsl:message>		-->

			<xsl:apply-templates select="//SADefinition[@SAObjMinorTypeName='Data Element' and translate(@SAObjId,' ','')=concat('_',$DELinkId)]" mode="class-attribute-find-DE"/>

	</xsl:template>
		

	<xsl:template match="SADefinition" mode="class-attribute-find-DE">

		<xsl:variable name="DataDomainLink"><xsl:value-of select="translate(./SAProperty[@SAPrpName='Domain']/SALink/@SALinkIdentity,' ','')"/></xsl:variable>
		<xsl:variable name="DEName"><xsl:value-of select="@SAObjName"/></xsl:variable> <!-- Name of Data Element -->
		<!--<xsl:message terminate="no"><xsl:text>DEName='</xsl:text><xsl:value-of select="@SAObjName"/><xsl:text>'</xsl:text></xsl:message>		-->
		
		<xsl:variable name="DEDescription"><xsl:choose><xsl:when test="string-length(./SAProperty[@SAPrpName='Beskrivelse']/@SAPrpValue)>0"><xsl:value-of select="./SAProperty[@SAPrpName='Beskrivelse']/@SAPrpValue"/></xsl:when><xsl:otherwise><xsl:value-of select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/></xsl:otherwise></xsl:choose></xsl:variable> <!-- Data Element description -->
		<!-- <xsl:message terminate="no"><xsl:text>DEDescription='</xsl:text><xsl:value-of select="$DEDescription"/><xsl:text>'</xsl:text></xsl:message>		-->
	
		<xsl:variable name="typeName"><xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Data Domain' and @SAObjId=concat('_',$DataDomainLink)]/@SAObjName"/><xsl:text>Type</xsl:text></xsl:variable>

		<xsl:message terminate="no">
			<xsl:text>
		  typeName: </xsl:text>
			<xsl:value-of select="$typeName"/>
		</xsl:message>
 
		<xsl:element name="xs:element">
			<xsl:attribute name="name"><xsl:value-of select="$DEName"/></xsl:attribute>
			<!--<xsl:attribute name="name"><xsl:value-of select="@SALinkName"/></xsl:attribute> -->
			<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$typeName"/></xsl:attribute>

			<!-- Annotation for each element in the class xsd -->

			<xsl:if test="string-length($DEDescription)>0">
				<xsl:element name="xs:annotation">
					<xsl:element name="xs:documentation">
						<!-- <xsl:text>Template match SALink called from Class</xsl:text> -->
						<xsl:value-of select="$DEDescription"/>
					</xsl:element>
				</xsl:element>
			</xsl:if>

		</xsl:element>
	</xsl:template>
	


<!-- Define VIEWS as complexTypes from the Data Structures -->

	<xsl:template match="SADefinition[@SAObjMinorTypeName='Data Structure']">
		<xsl:variable name="GUID">
			<xsl:text>sa:guid-</xsl:text><xsl:value-of select="./SAProperty[@SAPrpName='GUID']/@SAPrpValue"/>
		</xsl:variable>
		<xsl:variable name="ThisClassName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="SAObjName">
			<xsl:value-of select="@SAObjName"/>
		</xsl:variable>
		<xsl:variable name="ThisFileName">
			<xsl:value-of select="$ThisClassName"/><xsl:text>Type</xsl:text><xsl:text>.xsd</xsl:text>
		</xsl:variable>
		<xsl:variable name="ThisUniqueClassID">
			<xsl:value-of select="@SAObjId"/>
		</xsl:variable>
		<xsl:variable name="IsIOStructure">
			<xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Class Attribute']/SAProperty[@SAPrpName='InOutParam' and (@SAPrpValue='I' or @SAPrpValue='O')]/../SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate(translate($ThisUniqueClassID,' ',''),'_','')]/../../SAProperty[@SAPrpName='InOutParam']/@SAPrpValue"/>
			<!-- Der eksisterer en attribut af typen "I" eller typen "O", som har et SALink til denne klasse  -->
			<!--
			<xsl:value-of select="local-name(//SADefinition[@SAObjMinorTypeName='Class Attribute']/SAProperty[@SAPrpName='InOutParam' and (@SAPrpValue='I' or @SAPrpValue='O')]/../SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate(translate($ThisUniqueClassID,' ',''),'_','')])"/>
			-->
		</xsl:variable>
		<xsl:message terminate="no">
			<xsl:text>
		Found Data Structure Definition: </xsl:text>
			<xsl:value-of select="$ThisClassName"/>
			<xsl:if test="$IsIOStructure!=''">
			<xsl:text> (IO) </xsl:text>
			</xsl:if>
		</xsl:message>
		<xsl:text>

</xsl:text>


		<!-- Generate File Mapping -->
		<xsl:element name="mapping">
			<xsl:element name="theUri"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:element>
			<xsl:element name="theXpath"><xsl:text>view/</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:element>
		</xsl:element>
		<xsl:text> 

</xsl:text>

		<xsl:comment>
			<xsl:text>view/</xsl:text><xsl:value-of select="$ThisFileName"/>
		</xsl:comment>
		<xsl:text>
&lt;?xml version="1.0" encoding="</xsl:text>
		<xsl:value-of select="$OutputEncoding"/>
		<xsl:text>"?&gt;
</xsl:text>
		<xsl:element name="xs:schema" xmlns:tsi="http://toldskat.dk/xml/schemas/raplet/2005/01/01/">
			<xsl:attribute name="targetNamespace"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute>
			<xsl:attribute name="elementFormDefault">qualified</xsl:attribute>
			<xsl:attribute name="attributeFormDefault">unqualified</xsl:attribute>
			<xsl:attribute name="version">1.0</xsl:attribute>
			<!--<xsl:attribute name="xmlns:tsi"><xsl:value-of select="$OutputTargetNamespace"/></xsl:attribute> --> <!-- fixed in subsequent pass -->
			<xsl:attribute name="xmlns:xs">http://www.w3.org/2001/XMLSchema</xsl:attribute>
			<xsl:attribute name="xmlns:MR"><xsl:value-of select="$MetadataNamespace"/></xsl:attribute>
			<!--<xsl:attribute name="MR:GUID"><xsl:value-of select="$GUID"/></xsl:attribute>-->



			<xsl:element name="rdf:Description">
				<xsl:attribute name="rdf:about"><xsl:value-of select="$GUID"/></xsl:attribute>
				<xsl:attribute name="rdfs:label"><xsl:value-of select="$SAObjName"/></xsl:attribute>
				<xsl:element name="MR:generates">
					<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
				</xsl:element>
			</xsl:element>

			<xsl:if test="string-length(./SAProperty[@SAPrpName='Description']/@SAPrpValue)>0">
				<xsl:element name="xs:annotation">
				<xsl:element name="xs:documentation">
						<!-- <xsl:text>Template match Data Structure</xsl:text> -->
						<!--<xsl:value-of
						select="./SAProperty[@SAPrpName='Description']/@SAPrpValue"/> -->
					</xsl:element>
				</xsl:element>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="$IsIOStructure!=''">
					<xsl:element name="xs:include">
						<xsl:attribute name="schemaLocation"><xsl:text>../context/KontekstType.xsd</xsl:text></xsl:attribute>
					</xsl:element>

					<xsl:text>

					<!-- Generate RDF component -->

					</xsl:text><xsl:comment>&lt;rdf:Description&gt;</xsl:comment>
					<xsl:element name="rdf:Description">
					<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
					<xsl:element name="MR:includes">
						<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:text>KontekstType.xsd</xsl:text></xsl:attribute>
						</xsl:element>
					</xsl:element>
				</xsl:when>
			</xsl:choose>

			<!--<xsl:apply-templates select=".//p-element" mode="declaration"/> -->
			<xsl:apply-templates select="./SAProperty[@SAPrpName='Description']/SALink" mode="structure-element-declaration">
				<xsl:with-param name="ThisFileName"><xsl:value-of select="$ThisFileName"/></xsl:with-param>
			</xsl:apply-templates>
			<xsl:apply-templates select="./SAProperty[@SAPrpName='Description']/SALink" mode="structure-datastructure-declaration">
				<xsl:with-param name="ThisFileName"><xsl:value-of select="$ThisFileName"/></xsl:with-param>
			</xsl:apply-templates>
			<!--<xsl:apply-templates select=".//p-sequence" mode="declaration">
				<xsl:with-param name="ThisFileName"><xsl:value-of select="$ThisFileName"/></xsl:with-param>
			</xsl:apply-templates>
			<xsl:apply-templates select=".//p-choice" mode="declaration">
				<xsl:with-param name="ThisFileName"><xsl:value-of select="$ThisFileName"/></xsl:with-param>
			</xsl:apply-templates> -->

			
			<xsl:variable name="elementName">
				<xsl:value-of select="$ThisClassName"/>
			</xsl:variable>
			<xsl:variable name="typeName">
				<xsl:value-of select="$elementName"/>
				<xsl:text>Type</xsl:text>
			</xsl:variable>
			<xsl:element name="xs:element">
				<xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
				<xsl:choose>
					<xsl:when test="$IsIOStructure!=''">
						<xsl:element name="xs:complexType">
							<xsl:element name="xs:complexContent">
								<xsl:element name="xs:extension">
									<xsl:attribute name="base"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$typeName"/></xsl:attribute>
									<!-- Define revision attribute if revision parameter is defined -->
									<xsl:if test="$revision!=''">
										<xsl:element name="xs:attribute">
											<xsl:attribute name="name"><xsl:text>revision</xsl:text></xsl:attribute>
											<xsl:element name="xs:simpleType">
												<xsl:element name="xs:restriction">
													<xsl:attribute name="base"><xsl:text>xs:string</xsl:text></xsl:attribute>
													<xsl:element name="xs:pattern">
														<xsl:attribute name="value">
															<xsl:value-of select="$revision"/>
														</xsl:attribute>
													</xsl:element>
												</xsl:element>
											</xsl:element>
										</xsl:element>
									</xsl:if>

								</xsl:element>
							</xsl:element>
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$typeName"/></xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:element>

			<xsl:element name="xs:complexType">
				<xsl:attribute name="name"><xsl:value-of select="$typeName"/></xsl:attribute>


				<xsl:choose>

					<xsl:when test="$IsIOStructure=''">
						<xsl:if test="count(./SAProperty[@SAPrpName='Description']/p-block/p-sequence/p-element)=1">
							<xsl:text>
					&lt;xs:sequence&gt;
							</xsl:text>
							<xsl:if test="@minOccurs">
								<xsl:attribute name="minOccurs"><xsl:value-of select="normalize-space(@minOccurs)"/></xsl:attribute>
							</xsl:if>
					<xsl:if test="name(following-sibling::node()[local-name(.)!=''][1])='p-maxOccurs'">
						<xsl:attribute name="maxOccurs"><xsl:value-of select="normalize-space(following-sibling::node()[local-name(.)!=''][1])"/></xsl:attribute>
					</xsl:if>
						</xsl:if>
						<xsl:apply-templates mode="structure"/>
						<xsl:if test="count(./SAProperty[@SAPrpName='Description']/p-block/p-sequence/p-element)=1">
							<xsl:text>
					&lt;/xs:sequence&gt;
							</xsl:text>
						</xsl:if>
					</xsl:when>
					
				<!--</xsl:element>-->
				

					<xsl:otherwise>
							<xsl:text>
					&lt;xs:sequence&gt;
							</xsl:text>
							<xsl:element name="xs:element">
								<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:Kontekst</xsl:text></xsl:attribute>
							</xsl:element>

							<xsl:if test="count(.//p-block/p-sequence/*[local-name(.)!='' and local-name(.)!='p-comment'])>0">
								<xsl:if test="$IsIOStructure='I'">
									<xsl:text>
							&lt;xs:sequence&gt;
									</xsl:text>
									</xsl:if>
									<xsl:if test="$IsIOStructure='O'">
										<xsl:text>
							&lt;xs:sequence minOccurs="0"&gt;
										</xsl:text>
									</xsl:if>
									<xsl:apply-templates mode="structure"/>
									<xsl:text>
							&lt;/xs:sequence&gt;
									</xsl:text>
							</xsl:if>
								<xsl:text>
						&lt;/xs:sequence&gt;
								</xsl:text>
					</xsl:otherwise>

				</xsl:choose>
				
			</xsl:element>
		</xsl:element>
	</xsl:template>
	


<!-- Støttefunktion til Data Structure declaration. Finder definitioner på de enkeltstående Data Elements der refereres til i datastrukturen 
		Ud fra en Data structur findes den SALink der 
			- binder en 'Class Attribute' med en Class
			- hvis SADefinition har samme Data Element som source som peges på af Data Structure.
		Der bør kun være een af denne slags. Hvis der er flere skal man inkludere et XSD element der defineres ud fra Data Elementet selv.
-->
	<xsl:template match="SALink" mode="structure-element-declaration">
		<xsl:param name="ThisFileName"/>
		<xsl:variable name="SAObjId">
			<xsl:value-of select="@SALinkIdentity"/>
		</xsl:variable>
		
		<xsl:variable name="AttributeRefs"><xsl:value-of select="count(//SADefinition[@SAObjMinorTypeName='Class Attribute']/SAProperty[@SAPrpName='Class Name' and ../SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate($SAObjId,' ','')]])"/></xsl:variable>
		
		<xsl:choose>
			<!--<xsl:when test="1=1">-->

			<xsl:when test="$AttributeRefs != 1">

				<!-- Der er flere klasser der kvalificerer dette Data Element -->
				<!-- Definer et selvstændigt Data Element, og inkluder det -->
				<xsl:variable name="fileName">
					<xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Data Element' and translate(@SAObjId,'_','')=translate($SAObjId,' ','')]/@SAObjName"/><xsl:text>.xsd</xsl:text>
				</xsl:variable>

				<xsl:choose>
					<xsl:when test="$AttributeRefs=0 and string-length($fileName)>4">
						<xsl:element name="xs:include">
							<xsl:attribute name="schemaLocation"><xsl:text>../operational/</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
						</xsl:element>
					</xsl:when>
					<xsl:when test="$AttributeRefs>1 and string-length($fileName)>4">
						<xsl:element name="xs:include">
							<xsl:attribute name="schemaLocation"><xsl:text>../types/</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
						</xsl:element>
					</xsl:when>
				</xsl:choose>	
				
				<!-- Generate RDF component -->
				<xsl:text>
				</xsl:text><xsl:comment>&lt;rdf:Description i SALink mode structure-element-declaration when&gt;</xsl:comment>
				<xsl:element name="rdf:Description">
					<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
					<xsl:element name="MR:includes">
						<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
					</xsl:element>
				</xsl:element>
				
			</xsl:when>
			<xsl:otherwise>
				<!-- Der er kun een klasse der kvalificerer dette Data Element. Inkluder klassen -->

				<xsl:element name="rdf:Description">
					<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
					<xsl:apply-templates select="//SADefinition[@SAObjMinorTypeName='Class Attribute']/SAProperty[@SAPrpName='Class Name' and ../SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate($SAObjId,' ','')]]" mode="include-element">
						<xsl:with-param name="Kurt">
							<xsl:value-of select="$ThisFileName"/>
						</xsl:with-param>
					</xsl:apply-templates>
				</xsl:element>

			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	
	
	<xsl:template match="SALink" mode="include-element">
		<xsl:param name="Kurt"/>

		<xsl:variable name="fileName"><xsl:value-of select="@SALinkName"/><xsl:text>.xsd</xsl:text></xsl:variable>

		<xsl:element name="xs:include">
			<xsl:attribute name="schemaLocation"><xsl:text>../class/</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
		</xsl:element>

		<xsl:variable name="LinkIdentity"><xsl:value-of select="@SALinkIdentity"/></xsl:variable>
				<xsl:text>
				</xsl:text><xsl:comment>&lt;rdf:Description i SALink mode include-element&gt;</xsl:comment>

				<!-- Generate RDF component -->
		<xsl:element name="MR:includes">
			<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
		</xsl:element>

	</xsl:template>
	


<!-- Støttefunktion til Data Structure definition. Finder definitioner på de andre datastrukturer der refereres til fra datastrukturen -->
	<xsl:template match="SALink" mode="structure-datastructure-declaration">
		<xsl:param name="ThisFileName"/>
		<xsl:variable name="SAObjId">
			<xsl:value-of select="@SALinkIdentity"/>
		</xsl:variable>

		<xsl:apply-templates select="//SADefinition[@SAObjMinorTypeName='Data Structure' and translate(@SAObjId,'_','')=translate($SAObjId,' ','')]" mode="include-datastructure">
			<xsl:with-param name="ThisFileName"><xsl:value-of select="$ThisFileName"/></xsl:with-param>
		</xsl:apply-templates>

	</xsl:template>
	
	

	<xsl:template match="SADefinition" mode="include-datastructure">
		<xsl:param name="ThisFileName"/>
		<xsl:variable name="fileName"><xsl:value-of select="@SAObjName"/><xsl:text>Type</xsl:text><xsl:text>.xsd</xsl:text></xsl:variable>
		
		<xsl:element name="xs:include">
			<xsl:attribute name="schemaLocation"><xsl:text>../view/</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
		</xsl:element>

				<!-- Generate RDF triplet -->
				<xsl:text>
				</xsl:text><xsl:comment>&lt;MR:includes i SADefinition mode include-datastructure&gt;</xsl:comment>
		<xsl:element name="rdf:Description">
			<xsl:attribute name="rdf:about"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$ThisFileName"/></xsl:attribute>
			<xsl:element name="MR:includes">
				<xsl:attribute name="rdf:resource"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$fileName"/></xsl:attribute>
			</xsl:element>
		</xsl:element>
			
	</xsl:template>
	
	
	<xsl:template match="p-block" mode="structure">
		<xsl:apply-templates mode="structure"/>
	</xsl:template>

	<xsl:template match="p-element" mode="structure">
		<xsl:param name="optional"/>
		<xsl:if test="name(parent::node())!='p-comment'">
			<xsl:variable name="elementName">
				<xsl:value-of select="@name"/>	
			</xsl:variable>
			<xsl:variable name="SAObjId">
				<xsl:value-of select="//SALink[../p-block//p-element[@name=$elementName] and @SALinkName=$elementName]/@SALinkIdentity"/>
			</xsl:variable>
			<xsl:choose>

				<!-- <xsl:when test="1=1"> -->
				
				<xsl:when test="count(//SADefinition[@SAObjMinorTypeName='Class Attribute']/SAProperty[@SAPrpName='Class Name' and ../SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate($SAObjId,' ','')]]) > 1">
					<xsl:comment>Der er flere klasser der kvalificerer dette Data Element. Dette skal rettes i kilderepository.</xsl:comment>
					<xsl:element name="xs:element">
						<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Data Element' and translate(@SAObjId,'_','')=translate($SAObjId,' ','')]/@SAObjName"/></xsl:attribute>
						<xsl:if test="string-length($optional)>0">
							<xsl:attribute name="minOccurs">0</xsl:attribute>
						</xsl:if>
					</xsl:element>
				</xsl:when>
				<xsl:otherwise>
					<xsl:element name="xs:element">
						<!--<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="//SADefinition[@SAObjMinorTypeName='Class Attribute' and ./SAProperty[@SAPrpName='Source Data']/SALink[translate(@SALinkIdentity,' ','')=translate($SAObjId,' ','')]]/@SAObjName"/></xsl:attribute> -->
						<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$elementName"/></xsl:attribute>
						<xsl:if test="string-length($optional)>0">
							<xsl:attribute name="minOccurs">0</xsl:attribute>
						</xsl:if>
					</xsl:element>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>

	<xsl:template match="p-sequence" mode="structure">
		<xsl:choose>
			<xsl:when test="name(preceding-sibling::node()[2])='p-comment'"> <!-- Brug erklæring hvis en sådan er lavet. Ellers lav en anonym sekvens -->

				<xsl:element name="xs:element">
					<xsl:attribute name="name"><!--<xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text>--><xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
					</xsl:attribute>
					<xsl:choose>
						<xsl:when test="count(./*) = 1 and 1=0"> 
							<!-- Hvis der reelt kun er eet element i denne sequence, skal der slet ikke laves en sequence - gælder kun anonyme sequences -->
							<xsl:apply-templates mode="structure"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:element name="xs:complexType">
								<xsl:element name="xs:sequence">
									<xsl:if test="@minOccurs">
										<xsl:attribute name="minOccurs"><xsl:value-of select="normalize-space(@minOccurs)"/></xsl:attribute>
									</xsl:if>
									<xsl:if test="name(following-sibling::node()[2])='p-maxOccurs'">
										<xsl:attribute name="maxOccurs"><xsl:value-of select="normalize-space(following-sibling::node()[2])"/></xsl:attribute>
									</xsl:if>
									<xsl:apply-templates mode="structure"/>
								</xsl:element>
							</xsl:element>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:element>

				<!--    changed to the above definition that declares elements locally -->
				<!--<xsl:element name="xs:element">
					<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
					</xsl:attribute>
				</x sl:element> -->

			</xsl:when>
			<xsl:otherwise>

				<xsl:choose>
					<xsl:when test="count(./*) = 1"> 
						<!-- Hvis der reelt kun er eet element i denne sequence, skal der slet ikke laves en sequence - gælder kun anonyme sequences -->
						<xsl:apply-templates mode="structure"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="xs:sequence">
							<xsl:apply-templates mode="structure"/>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>


				<!--<xsl:element name="xs:sequence">
					<xsl:apply-templates mode="structure"/>
				</xsl:element>-->
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>


	<!-- If structure has a declared name, then use reference to declared structure, otherwise continue with anonymous structure -->
	<xsl:template match="p-choice" mode="structure"> 
		<xsl:choose>
			<xsl:when test="name(preceding-sibling::node()[2])='p-comment'">

				<xsl:element name="xs:element">
					<xsl:attribute name="name"><!--<xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text>--><xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
					</xsl:attribute>
					<xsl:element name="xs:complexType">
						<xsl:choose>
							<xsl:when test="count(./*[node()]) = 1"> <!-- Hvis der reelt kun er eet element i denne choice, skal der slet ikke laves et choice -->
								<xsl:choose>
									<xsl:when test="count(./p-sequence/*)  = 1"> <!-- Hvis elementet i choice er en sekvens der kun indeholder eet element skal det erklæres -->
										<xsl:element name="xs:sequence"> <!-- Da complexType skal erklæres må vi definere en sekvens -->
											<xsl:apply-templates mode="structure"/>
										</xsl:element>
									</xsl:when>
									<xsl:otherwise>
										<xsl:apply-templates mode="structure"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:element name="xs:choice">
									<xsl:apply-templates mode="structure"/>
								</xsl:element>
							</xsl:otherwise>
						</xsl:choose>
				
						<!--<xsl:element name="xs:choice">
							<xsl:apply-templates mode="structure"/>
						</xsl:element> -->
					</xsl:element>
				</xsl:element>
			
				<!--    changed to the above definition that declares elements locally -->
				<!-- <xsl:element name="xs:element">
					<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
					</xsl:attribute>
				</xsl:element> -->
				
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="count(./*[node()]) = 1"> <!-- Hvis der reelt kun er eet element i denne choice, skal der slet ikke laves et choice -->
						<xsl:apply-templates mode="structure"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="xs:choice">
							<xsl:apply-templates mode="structure"/>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template match="p-optional" mode="structure">
		<xsl:choose>
			<xsl:when test="name(preceding-sibling::node()[2])='p-comment'">

				<xsl:element name="xs:element">
					<xsl:attribute name="name"><!--<xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text>--><xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
					</xsl:attribute>
					<xsl:element name="xs:complexType">
						<xsl:element name="xs:sequence">
							<xsl:attribute name="minOccurs">0</xsl:attribute>
							<xsl:attribute name="maxOccurs">1</xsl:attribute>
							<xsl:apply-templates mode="structure"/>
						</xsl:element>
					</xsl:element>
				</xsl:element>

				<!--    changed to the above definition that declares elements locally -->
				<!-- <xsl:element name="xs:element">
					<xsl:attribute name="ref"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
					</xsl:attribute>
				</xsl:element> -->

			</xsl:when>
			<xsl:when test="count(./*)>1">
				<xsl:element name="xs:sequence">
					<xsl:attribute name="minOccurs">0</xsl:attribute>
					<xsl:apply-templates mode="structure"/>
				</xsl:element>
			</xsl:when>
			<xsl:when test="count(./*)=1">
				<xsl:apply-templates mode="structure">
					<xsl:with-param name="optional">optional</xsl:with-param>
				</xsl:apply-templates>
			</xsl:when>
			<xsl:otherwise>
			
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="p-plus|p-maxOccurs" mode="structure"/>

	<xsl:template match="p-sequence" mode="declaration">
		<xsl:if test="name(preceding-sibling::node()[2])='p-comment'"> <!-- INGEN dummyerklæringer. Kun eksplicit navngivne erklæringer -->
			<xsl:variable name="elementName">
				<xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
			</xsl:variable>
			<xsl:variable name="typeName">
				<xsl:value-of select="$elementName"/>
				<xsl:text>Type</xsl:text>
			</xsl:variable>

			<xsl:element name="xs:element">
				<xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
				<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$typeName"/></xsl:attribute>
			</xsl:element>
		
			<xsl:element name="xs:complexType">
				<xsl:attribute name="name"><xsl:value-of select="$typeName"/></xsl:attribute>
				<xsl:element name="xs:sequence">
					<xsl:if test="@minOccurs">
						<xsl:attribute name="minOccurs"><xsl:value-of select="normalize-space(@minOccurs)"/></xsl:attribute>
					</xsl:if>
					<xsl:if test="name(following-sibling::node()[2])='p-maxOccurs'">
						<xsl:attribute name="maxOccurs"><xsl:value-of select="normalize-space(following-sibling::node()[2])"/></xsl:attribute>
					</xsl:if>
				<xsl:apply-templates mode="structure"/>
			</xsl:element>
		</xsl:element>
		
		</xsl:if> <!-- Indsat -->
		
	</xsl:template>


	<!-- If a comment name has been indicated, the choice is made a named type -->
	<xsl:template match="p-choice" mode="declaration">
		<xsl:if test="name(preceding-sibling::node()[2])='p-comment'"><!-- INGEN dummyerklæringer. Kun eksplicit navngivne erklæringer -->
			<xsl:variable name="elementName">
				<xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
			</xsl:variable>
			<xsl:variable name="typeName">
				<xsl:value-of select="$elementName"/>
				<xsl:text>Type</xsl:text>
			</xsl:variable>

			<xsl:element name="xs:element">
				<xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
				<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$typeName"/></xsl:attribute>
			</xsl:element>
		
			<xsl:element name="xs:complexType">
				<xsl:attribute name="name"><xsl:value-of select="$typeName"/></xsl:attribute>
				<xsl:choose>
					<xsl:when test="count(./*[node()]) = 1"> <!-- Hvis der reelt kun er eet element i denne choice, skal der slet ikke laves et choice -->
						<xsl:choose>
							<xsl:when test="count(./p-sequence/*)  = 1"> <!-- Hvis elementet i choice er en sekvens der kun indeholder eet element skal det erklæres -->
								<xsl:element name="xs:sequence"> <!-- Da complexType skal erklæres må vi definere en sekvens -->
									<xsl:apply-templates mode="structure"/>
								</xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates mode="structure"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:element name="xs:choice">
							<xsl:apply-templates mode="structure"/>
						</xsl:element>
					</xsl:otherwise>
				</xsl:choose>
				
				<!--<xsl:element name="xs:choice">
					<xsl:apply-templates mode="structure"/>
				</xsl:element> -->
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- If a comment name has been indicated, the choice is made a named type -->
	<xsl:template match="p-optional" mode="declaration">
		<xsl:if test="name(preceding-sibling::node()[2])='p-comment'"><!-- INGEN dummyerklæringer. Kun eksplicit navngivne erklæringer -->
			<xsl:variable name="elementName">
				<xsl:value-of select="preceding-sibling::node()[2][name()='p-comment']/p-element/@name"/>
			</xsl:variable>
			<xsl:variable name="typeName">
				<xsl:value-of select="$elementName"/>
				<xsl:text>Type</xsl:text>
			</xsl:variable>

			<xsl:element name="xs:element">
				<xsl:attribute name="name"><xsl:value-of select="$elementName"/></xsl:attribute>
				<xsl:attribute name="type"><xsl:value-of select="$nsPrefix"/><xsl:text>:</xsl:text><xsl:value-of select="$typeName"/></xsl:attribute>
			</xsl:element>
		
			<xsl:element name="xs:complexType">
				<xsl:attribute name="name"><xsl:value-of select="$typeName"/></xsl:attribute>
				<!--<xsl:choose> -->
					<!--<xsl:when test="count(./*[node()]) = 1">--> <!-- Hvis der reelt kun er eet element i denne choice, skal der slet ikke laves et choice -->
					<!--	<xsl:choose>
							<xsl:when test="count(./p-sequence/*)  = 1">--> <!-- Hvis elementet i choice er en sekvens der kun indeholder eet element skal det erklæres -->
					<!--			<xsl:element name="xs:sequence"> --><!-- Da complexType skal erklæres må vi definere en sekvens -->
					<!--				<xsl:apply-templates mode="structure"/>
								</xsl:element>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates mode="structure"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise> -->
						<xsl:element name="xs:sequence">
							<xsl:attribute name="minOccurs">0</xsl:attribute>
							<xsl:attribute name="maxOccurs">1</xsl:attribute>
							<xsl:apply-templates mode="structure"/>
						</xsl:element>
					<!-- </xsl:otherwise>
				</xsl:choose> -->
				
				<!--<xsl:element name="xs:choice">
					<xsl:apply-templates mode="structure"/>
				</xsl:element> -->
			</xsl:element>
		</xsl:if>
	</xsl:template>



	<!-- Bliver vist ikke brugt -->
	<!-- <xsl:template match="p-element" mode="declaration">
		<xsl:comment>KilroyWasHereDeclaration</xsl:comment>
		<xsl:element name="xs:include">
			<xsl:attribute name="schemaLocation"><xsl:text>../something/</xsl:text><xsl:value-of select="@name"/><xsl:text>.xsd</xsl:text></xsl:attribute>
		</xsl:element>
	</xsl:template> -->
</xsl:stylesheet>
